int freq=1000;    //Half of the frequency used for the block waves in hz
int T=1000/freq;  //The time of one blockwave in ms
int x=100;        //The division factor used to measure the peak voltage
int potPin = A0;  //The potpin used to measure the voltage
float Vtot=0;     //The measured difference between the capacitors by the arduino in V not corrected for offset
float Var=0;     //The measured difference between the capacitors by the arduino in V corrected for offset
int Vpos=2;       //Output pin 2 of the arduino
int Vneg=3;       //Output pin 3 of the arduino
float Voff=0; //offset voltage 
int buttonState = 0;         // variable for reading the pushbutton status

void setup() {
  pinMode(Vpos, OUTPUT);        //Decleration of output pin 2 of the Arduino nano
  pinMode(Vneg, OUTPUT);        //Decleration of output pin 3 of the Arduino nano
  pinMode(LED_BUILTIN, OUTPUT); //Decleration of the output LED
  Serial.begin(19200);          //Decleration of the baudrate
  pinMode(buttonPin, INPUT);    //Initialize the pushbutton pin as an input:
}
void loop() {
  digitalWrite(Vpos, 1);                //Creation of squarewave from pin 2           
  digitalWrite(Vneg, 0);                //Creation of squarewave from pin 2   
  //Delay to measure peak voltage
  delay(T/x); 
                           
  float Vout1 = analogRead(potPin);     //First measurement of the voltage
  //Delay to create blockwave
  delay(T-T/x);                        
  
  digitalWrite(Vpos, 0);                //Creation of squarewave from pin 2   
  digitalWrite(Vneg, 1);                //Creation of squarewave from pin 3
  //Delay to measure peak voltage
  delay(T/x); 
                            
  float Vout2 = analogRead(potPin);     //Second measurement of the voltage
  float Vout=abs(Vout1-Vout2);          //Calculation of the difference between the voltage measurements
  Vtot=0.999*Vtot+0.001*Vout; //Calculation of the running avarage
  Var=Vtot-Voff; //correcrion for offset
  //Delay to create blockwave
  delay(T-T/x);  

                 

  //If statement to determine if the LED should turn on based on the difference between the capacitors
   if(Var> 70){
   digitalWrite(LED_BUILTIN, HIGH);     
  }
  if(Var < 70){
    digitalWrite(LED_BUILTIN, LOW);
  }

  //When the button is pressed 5V goes on port A1. The offset is corrected. 
  buttonState = analogRead(A1);
  
  if (buttonState>1000 ) {
    Voff=Vtot;
  }
  Serial.println(Var); //Plotting of Var
  
}
